﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

using DHTMLX.Scheduler;

namespace SchedulerTest.Controllers
{
    public class ExportToICalController : BasicSchedulerController
    {
        //
        // GET: /ExportToICal/

        public override ActionResult Index()
        {
            var sched = new DHXScheduler();
 
            sched.Controller = "BasicScheduler";
            sched.Config.first_hour = 8;
            sched.LoadData = true;
            sched.EnableDataprocessor = true;
            sched.Config.multi_day = true;
            sched.Extensions.Add(SchedulerExtensions.Extension.Serialize);
            sched.InitialDate = new DateTime(2011, 9, 19);

            return View(sched);
        }

        public ActionResult Export()
        {
            Response.ContentType = "text/plain";
            Response.AppendHeader("content-disposition", "attachment; filename=dhtmlxScheduler.ics");       
            return Content(Request.Form["data"].ToString());
            
        }

    }
}
